function out = roundfib(in)
% ROUNDFIB rounds number to nearest Fibonacci number
%   OUT = ROUNDFIB(IN) rounds number IN to the nearest Fibonacci number.
%
%   See also FLOORFIB.
%
% (c) Joseph Y Cheng (jycheng@mrsrl.stanford.edu) 2012
%

% SVN info: 
%     Date:     $Date: 2013-12-09 17:14:59 -0800 (Mon, 09 Dec 2013) $
%     Revision: $Revision: 1389 $
%     Author:   $Author: jycheng $
%     Id:       $Id: roundfib.m 1389 2013-12-10 01:14:59Z jycheng $
    
    fo = 1; %% old
    fi = 1; %% current
    do = 1e10; %% old difference
    
    out = fi; %% init value
    
    while 1
        di = abs(in-fi); %% current difference
        if (di<do)
            %% update
            do = di;
            out = fi;
            %% increment 
            temp = fi;
            fi = fi+fo;
            fo = temp;
        else
            break;
        end
    end